
#property indicator_chart_window 
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red
//---- input parameters
extern int     TimeFrame=0;
extern int     Price          = 0;  // Apply to Price(0-Close;1-Open;
                                    // 2-High;3-Low;4-Median price;
                                    // 5-Typical price;6-Weighted Close) 
extern int     Length         = 9;  // Period of NonLagMA
extern int     Displace       = 0;  // DispLace or Shift 
extern int     Filter         = 0;  // Static filter in points
extern int     Color          = 1;  // Switch of Color mode (1-color)  
extern int     ColorBarBack   = 1;  // Bar back for color mode
extern double  Deviation      = 0;  // Up/down deviation        

//---- buffers
double B_Up[];
double B_Dn[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init()
{
   if(TimeFrame==0)
   {
      if(Period()==1) TimeFrame=5;
      if(Period()==5) TimeFrame=15;
      if(Period()==15) TimeFrame=30;
      if(Period()==30) TimeFrame=60;
      if(Period()==60) TimeFrame=240;
      if(Period()==240) TimeFrame=PERIOD_D1;
      if(Period()==PERIOD_D1) TimeFrame=PERIOD_W1;
      if(Period()==PERIOD_W1) TimeFrame=PERIOD_MN1;
   }
   //---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(0,B_Up);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(1,B_Dn);
   
   IndicatorShortName("NonLagMA MTF ("+Length+")");
   return(0);
}

void deinit()
{
   return(0);
}

void start()
{
   int      i,j;
   int      counted_bars=IndicatorCounted();
   int      limit=Bars-counted_bars+1;
   int      tLength=Length*TimeFrame/Period();

   if (limit==0) return;
   //----------------------------------------------------
   for(i=0;i<=limit;i++)
   {
      //Price,Length,Displace,Filter,Color,ColorBarBack,Deviation
      B_Up[i]=iCustom(NULL,0,"NonLagMA",Price,tLength,Displace,Filter,Color,ColorBarBack,Deviation,1,i);
      B_Dn[i]=iCustom(NULL,0,"NonLagMA",Price,tLength,Displace,Filter,Color,ColorBarBack,Deviation,2,i);
   }
   return(0);
}


